dojo.provide("com.ibm.team.workitem.example.web.ui.StarPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function() {

STYLE_STAR_ON= "star-on";
STYLE_STAR_OFF= "star-off";

dojo.declare(
   "com.ibm.team.workitem.example.web.ui.StarPart",
   [dijit._Widget, dijit._Templated],
   {
   templateString:
      '<div class="com-example-star-widget">'+
      '<div dojoAttachPoint="_star" dojoAttachEvent="onclick:_toggle" class="star star-on"></div>'+
      '</div>',
   /*
    * The css is loaded using the cssBindingSets extension point specified in plugin.xml
    */
   postCreate: function() {
      this._setSelection();
      this.workingCopy.addListener({
            path: ["attributes", this.attributeId],
            event: "onchange",
            listener: this,
            functionName: "_handleWorkingCopyChange"
         });      
   },
/*
* Get the attribute value from the working copy and set the star control using the attribute value
*/
   _setSelection: function() {
      var isOn = this.workingCopy.getValue(   {
            path: ["attributes", this.attributeId, "id"]
               })
      this._setIsOn(isOn == "true");
   },

   _isOn: function() {
      return dojo.hasClass(this._star, STYLE_STAR_ON);
   },
   
   _setIsOn: function(isOn) {
      dojo.removeClass(this._star, isOn ? STYLE_STAR_OFF : STYLE_STAR_ON);
      dojo.addClass(this._star, isOn ? STYLE_STAR_ON : STYLE_STAR_OFF);
   },
   
   _toggle: function(event) {
      var isOn= !this._isOn();
      /*
       * In version 2, set the working copy value
       */
      this.workingCopy.setValue({
         path: ["attributes", this.attributeId, "id"],
         attributeId: this.attributeId,
         value: isOn
      });
   },
   _handleWorkingCopyChange: function(parms) {
         this._setIsOn(parms.attributeValue === true);
      }
   }
);

})();
